function QuickBars_SlashCommand()
    if (QuickBars_Options_Frame:IsShown()) then
        QuickBars_Options_Frame:Hide();
    else
        QuickBars_Options_Frame:Show();
    end
end

function QuickBars_Toggle_Show()
    local Cur_Bar = getglobal("QuickBar"..string.format("%d", QuickBars_ID));
    if (Cur_Bar:IsShown()) then
        Cur_Bar:Hide();
    else
        Cur_Bar:Show();
    end
end

function QuickBars_onload(self)
    SLASH_QUICKBARS1 = "/quickbars";
    SLASH_QUICKBARS2 = "/qb";
    SlashCmdList["QUICKBARS"] = QuickBars_SlashCommand;

    self.Action_Button = {};
    self.Main_Button = getglobal(self:GetName().."_Anchor");
    
    --Credit to Mairelon's Basic State Headers for the SecureAnchorEnterTemplate code
    self.Main_Button:SetAttribute("*childraise-OnEnter", true);
    self.Main_Button:SetAttribute("*childstate-OnEnter", "enter");
	self.Main_Button:SetAttribute("*childstate-OnLeave", "leave");
    
    self:SetAttribute("statemap-anchor-enter", "1");
	self:SetAttribute("statemap-anchor-leave", ";");
    
    self:SetAttribute("delaystatemap-anchor-leave", "1:0");
	self:SetAttribute("delaytimemap-anchor-leave",  "1:1");
	self:SetAttribute("delayhovermap-anchor-leave", "1:true");
    
    self.Main_Button:SetAttribute("anchorchild", "$parent");
    
    for i=1, 6 do
        self.Action_Button[i] = getglobal(self:GetName().."_Anchor_Action"..string.format("%d",i));

        self.Action_Button[i]:SetAttribute("type1", "action");
        self.Action_Button[i]:SetAttribute("action", (self:GetID()-1)*6+i);
        
        self.Action_Button[i]:SetAttribute("newstate", "0,1");
        self.Action_Button[i]:SetAttribute("hidestates", "0");
        
        self:SetAttribute("addchild", self.Action_Button[i]);
    end
    self.Main_Button:SetAttribute("newstate", "0,1");
    self.Main_Button:SetAttribute("showstates", "*");
    self:SetAttribute("addchild", self.Main_Button);
    
    self:RegisterEvent("VARIABLES_LOADED");
end

function QuickBars_init(self)
    ActionButton_OnUpdate(arg1);
    QuickBars_Update(self:GetID());
    if (QuickBars_Options.Show[self:GetID()] == false) then
        self:Hide();
	else
		self:Show();
    end
end
